/*
 * Nomad Instrument Control Software
 *
 * Copyright 2011 Institut Laue-Langevin
 *
 * Licensed under the EUPL, Version 1.1 only (the "License");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 *
 * http://joinup.ec.europa.eu/software/page/eupl
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 */

#ifndef REALCAENSYx527DRIVER_H
#define REALCAENSYx527DRIVER_H

#include "CAENSYx527State.h"

namespace caen_syx527 {

class CAENSYx527Driver;

/**
 * Real implementation
 */
class RealCAENSYx527Driver : public CAENSYx527State {

public:

	/**
	 * Constructor.
	 *
	 * @param Link to the class which used the state
	 */
	RealCAENSYx527Driver(CAENSYx527Driver* owner);

	/**
	 * Destructor.
	 * Empty.
	 */
	virtual ~RealCAENSYx527Driver();

	/**
	 * Perform a init.
	 */
	virtual void init();

	/**
	 * Read the parameters.
	 */
	virtual void readParamChannels();

	/**
	* Write the parameters.
	*/
	virtual void writeParam(int iChannel,std::string Param,float value);

	/**
	 * power on.
	 */
	virtual void powerOn(int iChannel);

	/**
	 * power off.
	 */
	virtual void powerOff(int iChannel);


private:

	int32 m_oldValue;
};

}
#endif //REALCAENSYx527DRIVER_H
